| TagLib 1.13 |  |

Public Member Functions | Static Public Member Functions | Protected Member Functions | Friends | List of all members
TagLib::ID3v2::ChapterFrame Class Reference

An implementation of ID3v2 chapter frames. More...

`#include <chapterframe.h>`

Inheritance diagram for TagLib::ID3v2::ChapterFrame:
[legend]
Collaboration diagram for TagLib::ID3v2::ChapterFrame:
[legend]

## Public Member Functions
| ChapterFrame (const ID3v2::Header *tagHeader, const ByteVector &data)
| ChapterFrame (const ByteVector &elementID, unsigned int startTime, unsigned int endTime, unsigned int startOffset, unsigned int endOffset, const FrameList &embeddedFrames=FrameList())
virtual | ~ChapterFrame ()
ByteVector | elementID () const
unsigned int | startTime () const
unsigned int | endTime () const
unsigned int | startOffset () const
unsigned int | endOffset () const
void | setElementID (const ByteVector &eID)
void | setStartTime (const unsigned int &sT)
void | setEndTime (const unsigned int &eT)
void | setStartOffset (const unsigned int &sO)
void | setEndOffset (const unsigned int &eO)
const FrameListMap & | embeddedFrameListMap () const
const FrameList & | embeddedFrameList () const
const FrameList & | embeddedFrameList (const ByteVector &frameID) const
void | addEmbeddedFrame (Frame *frame)
void | removeEmbeddedFrame (Frame *frame, bool del=true)
void | removeEmbeddedFrames (const ByteVector &id)
virtual String | toString () const
PropertyMap | asProperties () const
Public Member Functions inherited from TagLib::ID3v2::Frame
virtual | ~Frame ()
ByteVector | frameID () const
unsigned int | size () const
void | setData (const ByteVector &data)
virtual void | setText (const String &text)
virtual String | toString () const =0
ByteVector | render () const
TAGLIB_DEPRECATED | Header (const ByteVector &data, bool synchSafeInts)
| Header (const ByteVector &data, unsigned int version=4)
virtual | ~Header ()
TAGLIB_DEPRECATED void | setData (const ByteVector &data, bool synchSafeInts)
void | setData (const ByteVector &data, unsigned int version=4)
ByteVector | frameID () const
void | setFrameID (const ByteVector &id)
unsigned int | frameSize () const
void | setFrameSize (unsigned int size)
unsigned int | version () const
void | setVersion (unsigned int version)
bool | tagAlterPreservation () const
void | setTagAlterPreservation (bool discard)
bool | fileAlterPreservation () const
bool | readOnly () const
bool | groupingIdentity () const
bool | compression () const
bool | encryption () const
bool | unsynchronisation () const
bool | dataLengthIndicator () const
ByteVector | render () const
TAGLIB_DEPRECATED bool | frameAlterPreservation () const

## Static Public Member Functions
static ChapterFrame * | findByElementID (const Tag *tag, const ByteVector &eID)
Static Public Member Functions inherited from TagLib::ID3v2::Frame
static Frame * | createTextualFrame (const String &key, const StringList &values)
static unsigned int | headerSize ()
static unsigned int | headerSize (unsigned int version)
static ByteVector | textDelimiter (String::Type t)
static unsigned int | size ()
static unsigned int | size (unsigned int version)

## Protected Member Functions
virtual void | parseFields (const ByteVector &data)
virtual ByteVector | renderFields () const
Protected Member Functions inherited from TagLib::ID3v2::Frame
| Frame (const ByteVector &data)
| Frame (Header *h)
Header * | header () const
void | setHeader (Header *h, bool deleteCurrent=true)
void | parse (const ByteVector &data)
virtual void | parseFields (const ByteVector &data)=0
virtual ByteVector | renderFields () const =0
ByteVector | fieldData (const ByteVector &frameData) const
String | readStringField (const ByteVector &data, String::Type encoding, int *position=0)
String::Type | checkTextEncoding (const StringList &fields, String::Type encoding) const
PropertyMap | asProperties () const

## Friends
class | FrameFactory

## Additional Inherited Members
Static Public Attributes inherited from TagLib::ID3v2::Frame
static const String | instrumentPrefix
static const String | commentPrefix
static const String | lyricsPrefix
static const String | urlPrefix
Static Protected Member Functions inherited from TagLib::ID3v2::Frame
static String::Type | checkEncoding (const StringList &fields, String::Type encoding)
static String::Type | checkEncoding (const StringList &fields, String::Type encoding, unsigned int version)
static ByteVector | keyToFrameID (const String &)
static String | frameIDToKey (const ByteVector &)
static String | keyToTXXX (const String &)
static String | txxxToKey (const String &)
static void | splitProperties (const PropertyMap &original, PropertyMap &singleFrameProperties, PropertyMap &tiplProperties, PropertyMap &tmclProperties)

## Detailed Description

An implementation of ID3v2 chapter frames.

This is an implementation of ID3v2 chapter frames. The purpose of this frame is to describe a single chapter within an audio file.

## Constructor & Destructor Documentation

## ◆ ChapterFrame() [1/2]

TagLib::ID3v2::ChapterFrame::ChapterFrame | ( | const ID3v2::Header * | tagHeader,
|  | const ByteVector & | data
| ) |  |

Creates a chapter frame based on data. tagHeader is required as the internal frames are parsed based on the tag version.

## ◆ ChapterFrame() [2/2]

TagLib::ID3v2::ChapterFrame::ChapterFrame | ( | const ByteVector & | elementID,
|  | unsigned int | startTime,
|  | unsigned int | endTime,
|  | unsigned int | startOffset,
|  | unsigned int | endOffset,
|  | const FrameList & | embeddedFrames = `FrameList()`
| ) |  |

Creates a chapter frame with the element ID elementID, start time startTime, end time endTime, start offset startOffset, end offset endOffset and optionally a list of embedded frames, whose ownership will then be taken over by this Frame, in embeddedFrames;

All times are in milliseconds.

## ◆ ~ChapterFrame()

virtual TagLib::ID3v2::ChapterFrame::~ChapterFrame | ( |  | ) |
| virtual

Destroys the frame.

## Member Function Documentation

## ◆ addEmbeddedFrame()

void TagLib::ID3v2::ChapterFrame::addEmbeddedFrame | ( | Frame * | frame | ) |

Add an embedded frame to the CHAP frame. At this point the CHAP frame takes ownership of the embedded frame and will handle freeing its memory.

Note
  Using this method will invalidate any pointers on the list returned by embeddedFrameList()

## ◆ asProperties()

PropertyMap TagLib::ID3v2::ChapterFrame::asProperties | ( |  | ) | const

## ◆ elementID()

ByteVector TagLib::ID3v2::ChapterFrame::elementID | ( |  | ) | const

Returns the element ID of the frame. Element ID is a null terminated string, however it's not human-readable.

See also
  setElementID()

## ◆ embeddedFrameList() [1/2]

const FrameList & TagLib::ID3v2::ChapterFrame::embeddedFrameList | ( |  | ) | const

Returns a reference to the embedded frame list. This is an FrameList of all of the frames embedded in the CHAP frame in the order that they were parsed.

This can be useful if for example you want iterate over the CHAP frame's embedded frames in the order that they occur in the CHAP frame.

Warning
  You should not modify this data structure directly, instead use addEmbeddedFrame() and removeEmbeddedFrame().

## ◆ embeddedFrameList() [2/2]

const FrameList & TagLib::ID3v2::ChapterFrame::embeddedFrameList | ( | const ByteVector & | frameID | ) | const

Returns the embedded frame list for frames with the id frameID or an empty list if there are no embedded frames of that type. This is just a convenience and is equivalent to:

embeddedFrameListMap()[frameID];
TagLib::ID3v2::ChapterFrame::embeddedFrameListMap
const FrameListMap & embeddedFrameListMap() const
TagLib::ID3v2::Frame::frameID
ByteVector frameID() const

See also
  embeddedFrameListMap()

## ◆ embeddedFrameListMap()

const FrameListMap & TagLib::ID3v2::ChapterFrame::embeddedFrameListMap | ( |  | ) | const

Returns a reference to the frame list map. This is an FrameListMap of all of the frames embedded in the CHAP frame.

This is the most convenient structure for accessing the CHAP frame's embedded frames. Many frame types allow multiple instances of the same frame type so this is a map of lists. In most cases however there will only be a single frame of a certain type.

Warning
  You should not modify this data structure directly, instead use addEmbeddedFrame() and removeEmbeddedFrame().

See also
  embeddedFrameList()

## ◆ endOffset()

unsigned int TagLib::ID3v2::ChapterFrame::endOffset | ( |  | ) | const

Returns zero based byte offset (count of bytes from the beginning of the audio file) of chapter's end.

Note
  If returned value is 0xFFFFFFFF, end time should be used instead.

See also
  setEndOffset()

## ◆ endTime()

unsigned int TagLib::ID3v2::ChapterFrame::endTime | ( |  | ) | const

Returns time of chapter's end (in milliseconds).

See also
  setEndTime()

## ◆ findByElementID()

static ChapterFrame * TagLib::ID3v2::ChapterFrame::findByElementID | ( | const Tag * | tag,
|  | const ByteVector & | eID
| ) |  |
| static

CHAP frames each have a unique element ID. This searches for a CHAP frame with the element ID eID and returns a pointer to it. This can be used to link CTOC and CHAP frames together.

See also
  elementID()

## ◆ parseFields()

virtual void TagLib::ID3v2::ChapterFrame::parseFields | ( | const ByteVector & | data | ) |
| protected virtual

Called by parse() to parse the field data. It makes this information available through the public API. This must be overridden by the subclasses.

Implements TagLib::ID3v2::Frame.

## ◆ removeEmbeddedFrame()

void TagLib::ID3v2::ChapterFrame::removeEmbeddedFrame | ( | Frame * | frame,
|  | bool | del = `true`
| ) |  |

Remove an embedded frame from the CHAP frame. If del is true the frame's memory will be freed; if it is false, it must be deleted by the user.

Note
  Using this method will invalidate any pointers on the list returned by embeddedFrameList()

## ◆ removeEmbeddedFrames()

void TagLib::ID3v2::ChapterFrame::removeEmbeddedFrames | ( | const ByteVector & | id | ) |

Remove all embedded frames of type id from the CHAP frame and free their memory.

Note
  Using this method will invalidate any pointers on the list returned by embeddedFrameList()

## ◆ renderFields()

virtual ByteVector TagLib::ID3v2::ChapterFrame::renderFields | ( |  | ) | const
| protected virtual

Render the field data back to a binary format in a ByteVector. This must be overridden by subclasses.

Implements TagLib::ID3v2::Frame.

## ◆ setElementID()

void TagLib::ID3v2::ChapterFrame::setElementID | ( | const ByteVector & | eID | ) |

Sets the element ID of the frame to eID. If eID isn't null terminated, a null char is appended automatically.

See also
  elementID()

## ◆ setEndOffset()

void TagLib::ID3v2::ChapterFrame::setEndOffset | ( | const unsigned int & | eO | ) |

Sets zero based byte offset (count of bytes from the beginning of the audio file) of chapter's end to eO.

See also
  endOffset()

## ◆ setEndTime()

void TagLib::ID3v2::ChapterFrame::setEndTime | ( | const unsigned int & | eT | ) |

Sets time of chapter's end (in milliseconds) to eT.

See also
  endTime()

## ◆ setStartOffset()

void TagLib::ID3v2::ChapterFrame::setStartOffset | ( | const unsigned int & | sO | ) |

Sets zero based byte offset (count of bytes from the beginning of the audio file) of chapter's start to sO.

See also
  startOffset()

## ◆ setStartTime()

void TagLib::ID3v2::ChapterFrame::setStartTime | ( | const unsigned int & | sT | ) |

Sets time of chapter's start (in milliseconds) to sT.

See also
  startTime()

## ◆ startOffset()

unsigned int TagLib::ID3v2::ChapterFrame::startOffset | ( |  | ) | const

Returns zero based byte offset (count of bytes from the beginning of the audio file) of chapter's start.

Note
  If returned value is 0xFFFFFFFF, start time should be used instead.

See also
  setStartOffset()

## ◆ startTime()

unsigned int TagLib::ID3v2::ChapterFrame::startTime | ( |  | ) | const

Returns time of chapter's start (in milliseconds).

See also
  setStartTime()

## ◆ toString()

virtual String TagLib::ID3v2::ChapterFrame::toString | ( |  | ) | const
| virtual

This returns the textual representation of the data in the frame. Subclasses must reimplement this method to provide a string representation of the frame's data.

Implements TagLib::ID3v2::Frame.

## Friends And Related Function Documentation

## ◆ FrameFactory

friend class FrameFactory
| friend

The documentation for this class was generated from the following file:

- chapterframe.h